/* U̷ CH372/CH375 + MCS51 + EEPROM24CXX
;
; Website:  http://winchiphead.com
; Email:    tech@winchiphead.com
; Author:   W.ch 2004.12
;
;****************************************************************************
UDISK
32KSRAM62256СU,滻ΪU
*/

/* MCS-51ƬCԵʾ */
#define MY_DISK_SIZE  0x00000040	/* U */

#pragma NOAREGS
#include <reg52.h>
#include "CH375INC.H"
#include  "USBDISK.H"

unsigned char mVarSetupRequest;						 //USB
unsigned char mVarSetupLength;				    	 //	ƴݳ
unsigned char  code * VarSetupDescr;			     //ƫƵַ
unsigned char idata VarUsbAddress;						 //USBַ

union {
unsigned int mDataLength;							//ݳ
unsigned char mdataLen[2];							//
} LEN;
unsigned int  XDataAdd;								//ݵַ
													//Ϊڴõ256洢õ

unsigned char	BcswStatus;							//CSW״̬
bit CH375FLAGERR;									//0
bit	CH375CONFLAG;                     				//ñ־
bit CH375BULKUP;									//ϴ
bit CH375BULKDOWN;									//´
bit CH375CSW;										//CSWϴ־
bit FSTALL;											//ݴ־
bit lastFSTALL;
unsigned char  *pBuf;								//˵2ϴ´ȫָ
unsigned char volatile xdata CH375_CMD_PORT _at_ 0xBDF1;		/* CH375˿ڵI/Oַ */
unsigned char volatile xdata CH375_DAT_PORT _at_ 0xBCF0;		/* CH375ݶ˿ڵI/Oַ */
unsigned char  xdata *pXDatbuf;								//洢ַָ
mREQUEST_PACKET  request;
MASS_PARA  MassPara;
sbit  CH375ACT  = P1^4;
unsigned char mSenseKey;
unsigned char mASC;
unsigned char mdCBWTag[4];						//dCBWTag

void DiskInit(){								//ӳڶSRAMгʼ,Ĭϸʽ
	unsigned char  xdata *IntData;
	unsigned int i;
	IntData=0;
	if(*IntData==0xEB){
		IntData++;
		if(*IntData==0x3E){
			  IntData++;
			  if(*IntData==0x90)return;
			}
		}		// ļϢ򲻸ʽ
	IntData=0;								//ԼдFATļϵͳ
	for (i=0;i!=0X200;i++){
	 *IntData=DBR[i];
		IntData++;
	}
									//ԼдFATļϵͳ
	for (i=0;i!=0X200;i++){
	 *IntData=FAT[i];
		IntData++;
	}
	if ( DBR[0x11] == 2 ) {  // FAT
		for (i=0;i!=0X200;i++){
		 *IntData=FAT[i];
			IntData++;
		}
	}								//ԼдDIRļϵͳ
	for (i=0;i!=0X200;i++){
	 *IntData=ROOT[i];
		IntData++;
	}

}

#define Delay1us()	  /* MCS51,ٶȽ,ȫҪӳ */

//void Delay1us(){  /* MCS51,ٶȽ,ȫҪӳ */
//	for ( i=DELAY_START_VALUE; i!=0; i-- );
//}

void	Delay2us( )
{
	unsigned char i;
#define DELAY_START_VALUE	1  								/* ݵƬʱѡֵ,20MHzΪ0,30MHzΪ2 */
	for ( i=DELAY_START_VALUE; i!=0; i-- );
}

/* ʱ50,ȷ */
void	Delay50ms( )
{
	unsigned char i, j;
	for ( i=200; i!=0; i-- ) for ( j=250; j!=0; j-- );
}

void CH375_WR_CMD_PORT( unsigned char cmd ) { 				 /* CH375˿д,ڲС4uS,ƬϿʱ */
	Delay2us( );
	CH375_CMD_PORT=cmd;
	Delay2us( );
}

void CH375_WR_DAT_PORT( unsigned char dat ) { 				 /* CH375ݶ˿д,ڲС1.5uS,ƬϿʱ */
	CH375_DAT_PORT=dat;
  	Delay1us( );  /* ΪMCS51Ƭʵʱ */
}

unsigned char CH375_RD_DAT_PORT() {  						/* CH375ݶ˿ڶ,ڲС1.5uS,ƬϿʱ */
 	Delay1us( );  /* ΪMCS51Ƭʵʱ */
	return( CH375_DAT_PORT );
}

/* CH375ʼӳ */
void	CH375_Init( )
{
	unsigned char i;
/* USBģʽ, Ҫ */
	CH375_WR_CMD_PORT( CMD_SET_USB_MODE );
	CH375_WR_DAT_PORT( 1 );  									/* Ϊʹù̼USB豸ʽ */
	Delay2us( );
	for ( i=0xff; i!=0; i-- ) {  											/* ȴɹ,ͨҪȴ10uS-20uS */
		if ( CH375_RD_DAT_PORT()==CMD_RET_SUCCESS ) break;
	}
/* ж,ٶCH375INT0 */
	IT0 = 0;  /* ⲿźΪ͵ƽ */
	IE0 = 0;  /* жϱ־ */
	EX0 = 1;  /* CH375ж */
}

//*****************************************************************************
//BLOCK ONLY  The Thirteen Cases

void  BulkThirteen(unsigned char Case)
{
	switch(Case)
	{
	case CASEOK:
	case CASE1:     									/* Hn=Dn*/
	case CASE6:     									/* Hi=Di*/
		BcswStatus = 0;
		break;
	case CASE12:    									/* Ho=Do*/
		BcswStatus = 0;
		break;

	case CASE2:     									/* Hn<Di*/
	case CASE3:     									/* Hn<Do*/

		CH375_WR_CMD_PORT(CMD_SET_ENDP7);				//˵2ϴ
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
														//ϴ˵һSTALL // may or may-not
		BcswStatus =2;
		break;

	case CASE4:     									/* Hi>Dn*/
	case CASE5:     									/* Hi>Di*/


		CH375_WR_CMD_PORT(CMD_SET_ENDP7);					//˵2ϴ
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
														//ϴ˵һSTALL
		BcswStatus= 1;									//CSW_GOOD or CSW_FAIL
		break;


	case CASE7:    										 /* Hi<Di*/
	case CASE8:     									/* Hi<>Do */

			CH375_WR_CMD_PORT(CMD_SET_ENDP7);					//˵2ϴ
			CH375_WR_DAT_PORT(0x0f);
			FSTALL=1;
													//ϴ˵һSTALL
		BcswStatus = 2;
		break;

	case CASE9:     										/* Ho>Dn*/
	case CASE11:    									/* Ho>Do*/

        CH375_WR_CMD_PORT(CMD_SET_ENDP6);					//˵2ϴ
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
													//ϴ˵һSTALL
	BcswStatus =1;									//CSW_GOOD or CSW_FAIL
		break;

	case CASE10:    								/* Ho<>Di */
	case CASE13:    								/* Ho<Do*/

		CH375_WR_CMD_PORT(CMD_SET_ENDP7);					//˵2ϴ
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
													//ϴ˵һSTALL
        	CH375_WR_CMD_PORT(CMD_SET_ENDP6);					//˵2ϴ
		CH375_WR_DAT_PORT(0x0f);
													//ϴ˵һSTALL
		BcswStatus = 2;
		break;

	case CASECBW:   								/* invalid CBW */

    	CH375_WR_CMD_PORT(CMD_SET_ENDP7);
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
												//ϴ˵һSTALL
		CH375_WR_CMD_PORT(CMD_SET_ENDP6);
		CH375_WR_DAT_PORT(0x0f);
												//ϴ˵һSTALL

		BcswStatus = 2;
		break;

	case CASECMDFAIL:

  		CH375_WR_CMD_PORT(CMD_SET_ENDP7);
		CH375_WR_DAT_PORT(0x0f);
		FSTALL=1;
												//ϴ˵һSTALL
		BcswStatus= 1;
		break;

	default:
		break;
	}
}
//*********************************************************

//UFI  CMD
void UFI_Hunding(void ){
		switch(MassPara.cbw.cbwcb.buf1[0]){
			case INQUIRY:
				UFI_inquiry();
			break;
			case WRITE:
               UFI_write();
			break;
			case TES_UNIT:
				UFI_testUnit();
			break;
			case READ:
				UFI_read10();
			break;
			case REQUEST_SENSE:
				UFI_requestSense();
			break;
			case READ_CAPACITY:
                UFI_readCapacity();
			break;
			case VERIFY:
				UFI_verify();
				break;
		//	case 0x23:

		//	break;
		//	case MODE_SELECT:
			//	UFI_modeSlect();
		//	break;
			case MODE_SENSE:
				UFI_modeSense();
			break;
									case MODE_SENSE5:
								UFI_modeSense5();
									break;
		//	case WRITE_BUFFER:
		//		UFI_writeBuf();
	//		break;
	//		case PREVENT:
		//	break;
	//		case FORMAT_UNIT:
		//		UFI_format();
	//		break;
	//		case RELEASE:
	//		break;
			case STA_STO_UNIT:
				UFI_staStoUnit();
			break;
			case PRE_OR_MED:
				UFI_perOrMed();
			break;
			default:
				mSenseKey=5;
				mASC=0x20;
				BcswStatus=1;
				CH375BULKUP=0;
				BulkThirteen(CASECBW);
				break;
			}
}

/*//ufiЭ鴦
void  UFI_format(void ){
					//ʽ֧
		mSenseKey=5;
		mASCQ=0;
		mASC=0x20;
		BulkThirteen(CASECMDFAIL);
}*/
void  UFI_inquiry(void ){
		pBuf=DBINQUITY;					////ѯUϢ
		if(LEN.mDataLength>36)LEN.mDataLength=36;
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}
/*void  UFI_modeSlect(void ){
		BcswStatus=1;					//ģʽѡ֧
		mSenseKey=5;
		mASCQ=0;
		mASC=0x20;

}		//*/
void  UFI_modeSense(void ){
										//ģʽʶ
		if(MassPara.cbw.cbwcb.buf1[2]==0x3F){
			if ( LEN.mDataLength > sizeof(modesense3F) ) LEN.mDataLength = sizeof(modesense3F);
			pBuf=modesense3F;
			BcswStatus=0;
			mSenseKey=0;
			mASC=0;
		}
		else {
			CH375BULKUP=0;
									mSenseKey=5;
									mASC=0x20;

									BcswStatus=1;
			BulkThirteen(CASECMDFAIL);
	   	}
}
void  UFI_modeSense5(void ){

		if(MassPara.cbw.cbwcb.buf1[2]==0x3F){
			if ( LEN.mDataLength > sizeof(mode5sense3F) ) LEN.mDataLength = sizeof(mode5sense3F);
			pBuf=mode5sense3F;
			BcswStatus=0;
			mSenseKey=0;
			mASC=0;
		}
		else {
			CH375BULKUP=0;
			mSenseKey=5;
			mASC=0x20;
			BcswStatus=1;
			BulkThirteen(CASECMDFAIL);
	   	}
}
void  UFI_perOrMed(void ){				//Ƴ
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}

//Ϊ62256Եַ32KߵַȲ
void  UFI_read10(void){
													//ȡ
		LEN.mDataLength=MassPara.cbw.cbwcb.buf1[8]*512;
		pXDatbuf=MassPara.cbw.cbwcb.buf1[5]*512;
		pBuf=pXDatbuf;
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;

}
void  UFI_readCapacity(void ){
		if ( LEN.mDataLength > sizeof(DBCAPACITY) ) LEN.mDataLength = sizeof(DBCAPACITY);
		pBuf=(unsigned char*)DBCAPACITY;								//ȡ
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}

void  UFI_verify(void ){
		BcswStatus=0;		//У洢ռ
		mSenseKey=0;
		mASC=0;
					//ֻΪʾû洢
					//ʵһһҪ
}

void  UFI_requestSense(void ){
											//ʶ
	if ( FSTALL | lastFSTALL ) {
		lastFSTALL=FSTALL;
		FSTALL=0;
		MassPara.Sense.ErrorCode=0x70;
		MassPara.Sense.Reserved1=0;
		MassPara.Sense.SenseKey=mSenseKey;
		MassPara.Sense.Information[0]=0;
		MassPara.Sense.Information[1]=0;
		MassPara.Sense.Information[2]=0;
		MassPara.Sense.Information[3]=0;
		MassPara.Sense.AddSenseLength=0x0a;
		MassPara.Sense.Reserved2[0]=0;
		MassPara.Sense.Reserved2[1]=0;
		MassPara.Sense.Reserved2[2]=0;
		MassPara.Sense.Reserved2[3]=0;
		MassPara.Sense.AddSenseCode=mASC;
		MassPara.Sense.AddSenseCodeQua=00;
		MassPara.Sense.Reserved3[0]=0;
		MassPara.Sense.Reserved3[1]=0;
		MassPara.Sense.Reserved3[2]=0;
		MassPara.Sense.Reserved3[3]=0;
		pBuf=MassPara.buf;
		BcswStatus=0;
	}
	else {
		lastFSTALL=FSTALL;
		FSTALL=0;
		MassPara.Sense.ErrorCode=0x70;
		MassPara.Sense.Reserved1=0;
		MassPara.Sense.SenseKey=0x00;
		MassPara.Sense.Information[0]=0;
		MassPara.Sense.Information[1]=0;
		MassPara.Sense.Information[2]=0;
		MassPara.Sense.Information[3]=0;
		MassPara.Sense.AddSenseLength=0x0a;
		MassPara.Sense.Reserved2[0]=0;
		MassPara.Sense.Reserved2[1]=0;
		MassPara.Sense.Reserved2[2]=0;
		MassPara.Sense.Reserved2[3]=0;
		MassPara.Sense.AddSenseCode=0x00;
		MassPara.Sense.AddSenseCodeQua=00;
		MassPara.Sense.Reserved3[0]=0;
		MassPara.Sense.Reserved3[1]=0;
		MassPara.Sense.Reserved3[2]=0;
		MassPara.Sense.Reserved3[3]=0;
		pBuf=MassPara.buf;
		BcswStatus=0;
	}
}
void  UFI_staStoUnit(void ){
		CH375BULKDOWN=0;
		CH375BULKUP=0;
		BcswStatus=0;
			mSenseKey=0;
			mASC=0;
}
void  UFI_testUnit(void ){
			CH375BULKDOWN=0;
			CH375BULKUP=0;
		BcswStatus=0;			//UǷ׼
		mSenseKey=0;
		mASC=0;
}

void  UFI_write(void ){
	LEN.mDataLength=MassPara.cbw.cbwcb.buf1[8]*512;		//д
		pXDatbuf=MassPara.cbw.cbwcb.buf1[5]*512;		//ȡⲿRAM׵ַ
		pBuf=pXDatbuf;
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}

//UFI END
//**********************************************************************************
void CH375bulkUpData(){											//ö˵2ϴ
		unsigned char len;
		if(LEN.mDataLength>0x40){
			len=0x40;
			LEN.mDataLength-=0x40;
		}
		else {
			len= (unsigned char) LEN.mDataLength;
			LEN.mDataLength=0;
			CH375BULKUP=0;
		}
	CH375_WR_CMD_PORT(CMD_WR_USB_DATA7);						//д˵0
  	CH375_WR_DAT_PORT(len);
	do{
		CH375_WR_DAT_PORT( *pBuf );
		pBuf++;
	}while(--len);

}

void mCH375UpCsw()
{
		unsigned char i;													//Ϊ0
		pBuf=&MassPara.buf[0];
		CH375CSW=0;																	//ϴCSW
		CH375BULKUP=0;														//ȡϴ
		MassPara.buf[0]=0x55;												//dCSWSignature
		MassPara.buf[1]=0x53;
		MassPara.buf[2]=0x42;
		MassPara.buf[3]=0x53;
		MassPara.buf[4]=mdCBWTag[0];
		MassPara.buf[5]=mdCBWTag[1];
		MassPara.buf[6]=mdCBWTag[2];
		MassPara.buf[7]=mdCBWTag[3];
		MassPara.buf[8]=0;
		MassPara.buf[9]=0;
		MassPara.buf[10]=LEN.mdataLen[1];
		MassPara.buf[11]=LEN.mdataLen[0];
		MassPara.buf[12]=BcswStatus;
		CH375_WR_CMD_PORT(CMD_WR_USB_DATA7);						//д˵0
  		CH375_WR_DAT_PORT(13);
		for(i=0;i!=13;i++){
			CH375_WR_DAT_PORT(MassPara.buf[i]);
		}
}
void mCH375BulkOnly(){
			if(MassPara.buf[0]==0x55){
				if(MassPara.buf[1]==0x53){
				   if(MassPara.buf[2]==0x42){
				    	if(MassPara.buf[3]==0x43){
//							LEN.mDataLength=BIG_ENDIAN(MassPara.cbw.dCBWDatL);			//BOЭ鴦
							LEN.mdataLen[1]=*(unsigned char *)(&MassPara.cbw.dCBWDatL);  /* PCĵֽǰ16λתΪC51ĸֽǰ */
							LEN.mdataLen[0]=*( (unsigned char *)(&MassPara.cbw.dCBWDatL) + 1 );
							mdCBWTag[0]=MassPara.buf[4];
                             mdCBWTag[1]=MassPara.buf[5];
                              mdCBWTag[2]=MassPara.buf[6];
	                          mdCBWTag[3]=MassPara.buf[7];													  //ȡݳ
							  if(LEN.mDataLength){
									CH375BULKDOWN=(MassPara.cbw.bmCBWFlags&0X80)?0:1;	//жϴ´
									CH375BULKUP=(MassPara.cbw.bmCBWFlags&0X80)?1:0;
								}
						  // if(!CBWLUN){      		//ֻ֧һ
								CH375CSW=1;
								UFI_Hunding();
							//UFIЭ鴦
						//	}
							//	else ;//˴Ӧ
					   }
					   else{ CH375_WR_CMD_PORT(CMD_SET_ENDP7);							//˵2ϴ
								CH375_WR_DAT_PORT(0x0f);
				 		}
				  }
				   else{ CH375_WR_CMD_PORT(CMD_SET_ENDP7);							//˵2ϴ
								CH375_WR_DAT_PORT(0x0f);
				 		}
			     }
				 else{ CH375_WR_CMD_PORT(CMD_SET_ENDP7);							//˵2ϴ
								CH375_WR_DAT_PORT(0x0f);
				 		}
			 }
			else { CH375_WR_CMD_PORT(CMD_SET_ENDP7);							//˵2ϴ
						CH375_WR_DAT_PORT(0x0f);
				 		}
}

void mCH375BulkDownData(){
		unsigned char len;
		CH375_WR_CMD_PORT(CMD_RD_USB_DATA);		//
  		len=CH375_RD_DAT_PORT();				//
												//ж
			LEN.mDataLength-=len;				//ȫݳȼǰõĳ
	do{
		*pBuf=CH375_RD_DAT_PORT();				//ݽ洢
		pBuf++;
	}while(--len);
	if(LEN.mDataLength==0){														//Ϊ0,CSW
		CH375BULKDOWN=0;
		mCH375UpCsw();				//ϴCSW
	}
}

//*********************************************************
//˵0ϴ
void mCh375Ep0Up(){
	unsigned char i,len;
	if(mVarSetupLength){												//ȲΪ0峤ȵ
		if(mVarSetupLength<=8){
			len=mVarSetupLength;
			mVarSetupLength=0;
        }	//С8Ҫĳ
		else{
			len=8;
			mVarSetupLength-=8;
		}							                        		//ȴ88ܳȼ8
	    CH375_WR_CMD_PORT(CMD_WR_USB_DATA3);						//д˵0
       	CH375_WR_DAT_PORT(len);										//д볤
    	for(i=0;i!=len;i++)
        CH375_WR_DAT_PORT(request.buffer[i]);	              		//ѭд
    }
	else{
		CH375_WR_CMD_PORT(CMD_WR_USB_DATA3);						//д˵0
		CH375_WR_DAT_PORT(0);					                   //ϴ0ݣһ״̬׶
	}
}

//Աϴ
void mCh375DesUp(){
	unsigned char k;
	for (k=0; k!=8; k++ ) {
         request.buffer[k]=*VarSetupDescr;  								//θ8
         VarSetupDescr++;
    }
}

/* CH375жϷINT0,ʹüĴ1 */
void	mCH375Interrupt( ) interrupt 0 using 1
{
	unsigned char InterruptStatus;
	unsigned char length, len;
	CH375_WR_CMD_PORT(CMD_GET_STATUS);  									/* ȡж״̬ȡж */
	InterruptStatus =CH375_RD_DAT_PORT();  									/* ȡж״̬ */
							  												/* жϱ־,ӦINT0ж */
	switch(InterruptStatus){  // ж״̬
		case  USB_INT_EP2_OUT:  											// ˵´ɹ
			if(CH375BULKDOWN)mCH375BulkDownData();									//ϴݽ׶ϴ
			else{	 										//´жǷ
					CH375_WR_CMD_PORT(CMD_RD_USB_DATA);									//
					length=CH375_RD_DAT_PORT();
					if(!length)break;								//ݰΪ
																//ȶǳ
					for(len=0;len!=length;len++) MassPara.buf[len]=CH375_RD_DAT_PORT();	//ݶ뵽
					mCH375BulkOnly();

					if(!CH375BULKDOWN){
						if(CH375BULKUP)CH375bulkUpData();					//ϴ
						else if(!FSTALL)mCH375UpCsw();								//ûϴCSWϴ
																		//ϴݵ
					}
			}
			break;
		case   USB_INT_EP2_IN:
			if(CH375BULKUP)CH375bulkUpData();								//ϴ
			else if(CH375CSW)mCH375UpCsw();									//ϴCSW
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);								 //˵ϴɹ,δ
			break;
		case   USB_INT_EP1_IN:	 											//ж϶˵ϴɹδ
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);  //ͷŻ
			break;
		case   USB_INT_EP1_OUT:	  											//ж϶˵´ɹδ
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);  //ͷŻ
			break;
		case   USB_INT_EP0_SETUP: 											//ƶ˵㽨ɹ
	    	CH375FLAGERR=0;
			CH375_WR_CMD_PORT(CMD_RD_USB_DATA);
			length=CH375_RD_DAT_PORT();
			for(len=0;len!=length;len++)request.buffer[len]=CH375_RD_DAT_PORT();  // ȡ
			if(length==0x08){
			    mVarSetupLength=request.buffer[6]&0x7f;							//ƴݳΪ128
				if((request.r.bmReuestType)&0x40){         					 //δ
				}
				if((request.r.bmReuestType)&0x20){          					//δ
					if(request.buffer[1]==0xfe)request.buffer[0]=0;				//õ߼Ŀֻһ
				//	else if(request.buffer[1]==0x00);								//λ߼Ԫδ
				 }
				if(!((request.r.bmReuestType)&0x60)){          				//׼
					mVarSetupRequest=request.r.bRequest;							//ݴ׼
					switch(request.r.bRequest){  // ׼
						case DEF_USB_CLR_FEATURE:									//
							if((request.r.bmReuestType&0x1F)==0X02){					//Ƕ˵㲻֧
								switch(request.buffer[4]){
									case 0x82:
										CH375_WR_CMD_PORT(CMD_SET_ENDP7);					//˵2ϴ
										CH375_WR_DAT_PORT(0x8E);               			//˵
										if(CH375CSW)mCH375UpCsw();
										lastFSTALL=FSTALL;
										FSTALL=0;
										break;
									case 0x02:
										CH375_WR_CMD_PORT(CMD_SET_ENDP6);
										CH375_WR_DAT_PORT(0x80);				//˵2´
										if(CH375CSW)mCH375UpCsw();
										lastFSTALL=FSTALL;
										FSTALL=0;
										break;
									case 0x81:
										CH375_WR_CMD_PORT(CMD_SET_ENDP5);					//˵1ϴ
										CH375_WR_DAT_PORT(0x8E);
										break;
									case 0x01:
										CH375_WR_CMD_PORT(CMD_SET_ENDP4);					//˵1´
										CH375_WR_DAT_PORT(0x80);
										break;
									default:
										break;
								}
							}
							else{
								CH375FLAGERR=1;								//ֵ֧ԣô־
							}
							break;
						case DEF_USB_GET_STATUS:								//״̬
							request.buffer[0]=0;
							request.buffer[1]=0;								//ϴ״̬
							break;
						case DEF_USB_SET_ADDRESS:								//õַ
							VarUsbAddress=request.buffer[2];					//ݴUSBĵַ
							break;
						case DEF_USB_GET_DESCR: 								//
							if(request.buffer[3]==1)							//豸ϴ
								VarSetupDescr=DevDes;
							else if(request.buffer[3]==2)		 					//ϴ
								VarSetupDescr=ConDes;
							else if(request.buffer[3]==3) {
								if ( request.buffer[2]== 0 ) VarSetupDescr=LangDes;
								else VarSetupDescr=SerDes; 						//ַ
							}
							mCh375DesUp();											//֧
							break;
						case DEF_USB_GET_CONFIG:									//
							request.buffer[0]=0;									//û0
							if(CH375CONFLAG) request.buffer[0]=1;									//Ѿ1涨
							break;
						case DEF_USB_SET_CONFIG:                 					//
							CH375CONFLAG=0;
							CH375ACT=1;
							if ( request.buffer[2] != 0 ) {
								CH375CONFLAG=1;											//ñ־
								CH375ACT=0;												//ź
							}
							break;
						case DEF_USB_GET_INTERF:										//õӿ
							request.buffer[0]=1;									//ϴӿֻ֧һӿ
							break;
						case DEF_USB_SET_INTERF:										//ýӿ
							break;
						default :
							break;													//ֵ֧ı׼
					}
				}
			}
			else {  //ֵ֧Ŀƴ䣬8ֽڵĿƴ
				CH375FLAGERR=1;
			}
			if(!CH375FLAGERR) mCh375Ep0Up();										//ûд/ϴΪ0ϴΪ״̬
			else {
				CH375_WR_CMD_PORT(CMD_SET_ENDP3);								//ö˵1ΪSTALLָʾһ
				CH375_WR_DAT_PORT(0x0F);
			}
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);
			break;
		case   USB_INT_EP0_IN:
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);												//ƶ˵ϴɹ
			if(mVarSetupRequest==DEF_USB_GET_DESCR){								//ϴ
				mCh375DesUp();
				mCh375Ep0Up();
			}
			else if(mVarSetupRequest==DEF_USB_SET_ADDRESS){							//õַ
				CH375_WR_CMD_PORT(CMD_SET_USB_ADDR);
				CH375_WR_DAT_PORT(VarUsbAddress);								//USBַ,´USBַ
			}
			break;
		case   USB_INT_EP0_OUT:													//ƶ˵´ɹ
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);  //ͷŻ
			break;
		default:
			if((InterruptStatus&0x03)==0x03){									//߸λ
				FSTALL=0;
				CH375FLAGERR=0;													//0
				CH375CONFLAG=0;													//0
				mVarSetupLength=0;
				 CH375FLAGERR=0;												//0
				 CH375BULKUP=0;													//
				CH375BULKDOWN=0;
				 CH375CSW=0;
				FSTALL=0;
				CH375ACT=1;														//
			}
			else{																//֧
				;
			}
            CH375_WR_CMD_PORT (CMD_UNLOCK_USB);  //ͷŻ
			CH375_RD_DAT_PORT( );
			break;
	}
}

main( ) {
	Delay50ms( );	/* ʱȴCH375ʼ,ƬCH375ṩλź򲻱ʱ */
	Delay50ms( );	/* ʱȴCH375ʼ,ƬCH375ṩλź򲻱ʱ */
	DiskInit();		//SRAMгʼ,Ĭϸʽ,ôӦ˲
	CH375_Init( );  /* ʼCH375 */
    EA=1;
	while(1);
}
